
## 前言

数组在实战开发中，使用得相当频繁。前端同学通过接口拿到json数据后，往往需要把数据进行各种形式的变换和展示。这个时候，数组的常见操作，就发挥了很大的作用。

如果你对数组的基础知识不太熟悉，建议回去看看`03-JavaScript`的基础知识。

掌握了基础知识之后，我们再来看看，实战开发中，数组都有哪些常见操作。

## 数组的常见操作

### 从对象数组中，将属性的值提取为数组

一般人可能会想着通过 for 循环进行遍历，但这种做法不够简洁。

最佳答案：

```javascript
      const arr1 = [
        { skuId: "123", name: "商品1" },
        { skuId: "456", name: "商品2" },
        { skuId: "789", name: "商品3" }
      ];

      const skuIdArr = arr1.map(item => item.skuId); // 将数组 arr1 中的 skuId字段提取为一个新的数组
      console.log(JSON.stringify(skuIdArr));
```


打印结果：

```json
	["123","456","789"]
```


- 参考链接：<https://codeday.me/bug/20170426/12102.html>